export function FormOperator(obj) {
  const form = obj.map((item, index) => {
    return `<div>${makeElement(item, index)}</div>`
  });
  return `${form.join('\n')}<div class="fb-label"><button class="fb-btn" type="submit">ذخیره</button></div>`;
}

export function GetFormValue(form) {
  const value = {};
  if (form) {
    const elms = form.getElementsByTagName('input');
    const select = form.getElementsByTagName('select');
    const items = [...elms, ...select];
    for (let i = 0; i < items.length; i++) {
      if (form[i].type === InputType.RADIO) {
        if (form[i].checked) value[form[i].name] = form[i].value;
      } else {
        value[form[i].name] = form[i].value;
      }
    }
    return value;
  }
}

export function CheckValid(form) {
  if (form) {
    const elms = form.getElementsByTagName('input');
    const select = form.getElementsByTagName('select');
    const items = [...elms, ...select];
    for (let i = 0; i < items.length; i++) {
      if (form[i].required && !form[i].value) return false;
    }
    return true;
  }
}

const makeElement = (item, index) => {
  switch (item.type) {
    case InputType.INPUT:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><input name="${index}" required class="fb-input" placeholder="${item.placeholder || ''}" /></label>`;

    case InputType.TEXT_AREA:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><textarea name="${index}" class="fb-input" placeholder="${item.placeholder || ''}" ></textarea></label>`;

    case InputType.DESCRIPTION:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><textarea name="${index}" class="fb-input" placeholder="${item.placeholder || ''}" ></textarea></label>`;

    case InputType.NUMBER:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><input name="${index}" class="fb-input" type="number" placeholder="${item.placeholder || ''}"/></label>`;

    case InputType.IMAGE:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><input name="${index}" class="fb-input" type="file" placeholder="${item.placeholder || ''}" ></label>`;

    case InputType.FILE:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><input name="${index}" class="fb-input" type="file" placeholder="${item.placeholder || ''}" ></label>`;

    case InputType.RADIO:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span>
              ${item.options.map((i, indx) => {
        return `<input class="fb-radio" type="radio" name="${index}" value="${i.label}" id="radio${indx}"><label for="radio${indx}">${i.label}</label>`;
      }).join('\n')}</label>`;

    case InputType.CHECKBOX:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span>
              ${item.options.map((i, indx) => {
        return `<input class="fb-checkbox" type="checkbox" name="${index}" value="${i.label}" id="check${indx}"><label for="check${indx}">${i.label}</label>`;
      }).join('\n')}</label>`;

    case InputType.SELECT:
      return `<label class="fb-label"><span class="fb-label">${item.label}</span><select name="${index}" class="fb-input">
                <option disabled selected value="">${item.placeholder || item.label}</option>
              ${item.options.map(i => {
        return `<option value="${i.label}">${i.label}</option>`;
      })}</select></label>`;

    default:
      return '';
  }

};

// interface ControlModel {
//   index: number;
//   label: string;
//   placeholder: string;
//   type: string;
//   options: Option[];
//   validators: ValidatorsModel;
// }
//
// interface Option {
//   label: string;
// }
//
// interface ValidatorsModel {
//   required?: boolean
//   minLength?: string;
//   maxLength?: string;
//   min?: string;
//   max?: string;
// }

export const InputType = {
  INPUT: 'input',
  TEXT_AREA: 'text-area',
  DESCRIPTION: 'description',
  IMAGE: 'image',
  FILE: 'file',
  RADIO: 'radio',
  CHECKBOX: 'checkbox',
  SELECT: 'select',
  PLATE: 'plate-cartex-',
  NATIONAL_ID: 'nationalId',
  NUMBER: 'number',
  PHONE: 'phone',
  EMAIL: 'email',
  POSTAL_CODE: 'postalCode',
  SHEBA: 'sheba',
  DATE_SH: 'dateShamsi',
  LOCATION: 'location',
  PAYMENT_RIAL: 'paymentRial',
};
